=== debian/changelog ===
mini-init-asm (0.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1122134)

 -- Alex Myczko <tar@debian.org>  Sun, 07 Dec 2025 14:02:33 +0000
