=== debian/changelog ===
mini-init-asm (0.3.1+ds-3) unstable; urgency=medium

  * Add upstream co-maintainer to Uploaders.
  * debian/control:
    - bump Standards-Version to 4.7.3.
  * debian/watch: add upstream/debian version mangling for v-prefixed tags
    and +ds repacks.
  * debian/rules + debian/install:
    - install a unified binary path as /usr/bin/mini-init-asm.
  * debian/mini-init-asm.lintian-overrides: fix override context to match the
    installed binary path.
  * debian/mini-init-asm.manpages: install mini-init-asm(1).

 -- Bogdan Pedchenko <m0980701299@gmail.com>  Mon, 23 Feb 2026 19:58:00 +0000

mini-init-asm (0.3.1+ds-2) unstable; urgency=medium

  * d/rules: fix build on amd64.

 -- Alex Myczko <tar@debian.org>  Mon, 16 Feb 2026 22:51:11 +0000

mini-init-asm (0.3.1+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright:
    - relicense debian/* to upstream license.
    - bump years.

 -- Alex Myczko <tar@debian.org>  Mon, 16 Feb 2026 19:42:48 +0000
