=== debian/control ===
Source: mini-init-asm
Section: utils
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Uploaders: Bogdan Pedchenko <m0980701299@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 nasm,
Standards-Version: 4.7.3
Homepage: https://github.com/roots666/mini-init-asm
Vcs-Browser: https://salsa.debian.org/debian/mini-init-asm
Vcs-Git: https://salsa.debian.org/debian/mini-init-asm.git

Package: mini-init-asm
Architecture: arm64 amd64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: tiny PID 1 for containers
 This spawns your target process as its own process group, forwards signals to
 the whole group, reaps zombies, and optionally restarts your app on crash. On
 exit, it returns your app's status code (with configurable signal→exit
 mapping).
