=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_build:
ifeq ($(DEB_BUILD_ARCH), arm64)
	$(MAKE) build-arm64
	cp build/mini-init-arm64 build/mini-init-asm
else
	$(MAKE) build-amd64
	cp build/mini-init-amd64 build/mini-init-asm
endif

override_dh_auto_test:
	@echo moo
