=== debian/watch ===
Version: 5
Template: GitHub
Owner: roots666
Project: mini-init-asm
Uversion-Mangle: s/^v//
Dversion-Mangle: s/\+ds\d*$//
